import java.io.*;
import java.math.*;
import java.sql.*;
import java.text.*;

public class HandlingNullValues2 {
  Connection conn;
 
  public HandlingNullValues2() {
    try {
      DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
      conn = DriverManager.getConnection(
       "jdbc:oracle:thin:@dssw2k01:1521:orcl", "scott", "tiger");
    }
    catch (SQLException e) {
      System.err.println(e.getMessage());
      e.printStackTrace();
    }
  }

  public static void main(String[] args) 
   throws Exception, IOException {
    new HandlingNullValues2().process();
  }

  public void process() throws IOException, SQLException {
    Double     aDouble = null;
    int        rows    = 0;
    ResultSet  rslt    = null;
    Statement  stmt    = null;
    try {
      stmt = conn.createStatement();
      rslt = stmt.executeQuery(
       "select to_number( NULL ) from sys.dual");
      if (rslt.next()) {
        rows++;

        aDouble = new Double(rslt.getDouble(1));

        System.out.println("before wasNull() a Double = " + aDouble);

        if (rslt.wasNull()) 
          aDouble = null;

        System.out.println("after  wasNull() a Double = " + aDouble);
      }
      rslt.close();
      rslt = null;
      stmt.close();
      stmt = null;
    }
    catch (SQLException e) {
      System.err.println(e.getMessage());
    }
    finally {
      if (rslt != null) 
        try { rslt.close(); } catch (SQLException ignore) { }
      if (stmt != null) 
        try { stmt.close(); } catch (SQLException ignore) { }
    }
  }

  protected void finalize() 
   throws Throwable {
    if (conn != null) 
      try { conn.close(); } catch (SQLException ignore) { }
    super.finalize();
  }
}