import java.sql.SQLException;
import oracle.jdbc.driver.OracleConnection;
import oracle.jdbc.driver.OracleTypes;
import java.sql.SQLData;
import java.sql.SQLInput;
import java.sql.SQLOutput;
import oracle.sql.STRUCT;
import oracle.jpub.runtime.MutableStruct;

public class PersonIdentifierType implements SQLData
{
  public static final String _SQL_NAME = "SCOTT.PERSON_IDENTIFIER_TYPE_TYP";
  public static final int _SQL_TYPECODE = OracleTypes.STRUCT;

  private String m_code;
  private String m_description;
  private java.sql.Timestamp m_inactiveDate;

  /* constructor */
  public PersonIdentifierType()
  {
  }

  public void readSQL(SQLInput stream, String type)
  throws SQLException
  {
      setCode(stream.readString());
      setDescription(stream.readString());
      setInactiveDate(stream.readTimestamp());
  }

  public void writeSQL(SQLOutput stream)
  throws SQLException
  {
      stream.writeString(getCode());
      stream.writeString(getDescription());
      stream.writeTimestamp(getInactiveDate());
  }

  public String getSQLTypeName() throws SQLException
  {
    return _SQL_NAME;
  }

  /* accessor methods */
  public String getCode()
  { return m_code; }

  public void setCode(String code)
  { m_code = code; }


  public String getDescription()
  { return m_description; }

  public void setDescription(String description)
  { m_description = description; }


  public java.sql.Timestamp getInactiveDate()
  { return m_inactiveDate; }

  public void setInactiveDate(java.sql.Timestamp inactiveDate)
  { m_inactiveDate = inactiveDate; }

}
